# Hibernate 3 is only available in JBoss buildroots.  Avoid for now.
%bcond_with hibernate3

# Hash for jackson-datatype-hibernate-parent-2.3.0-1
%global commit ba59fce6ad2e611d33241c154859c80cac608269
%global artifact_version %{version}-1

%global name_h4 %{name}4
%if %{with hibernate3}
%global name_h3 %{name}3
%endif

Name:          jackson-datatype-hibernate
Version:       2.3.0
Release:       1%{?dist}
Epoch:         0
Summary:       Support for reading and writing Smile encoded data
License:       ASL 2.0
Group:         Development/Libraries
URL:           https://github.com/FasterXML/jackson-datatype-hibernate
Source0:       https://github.com/FasterXML/jackson-datatype-hibernate/archive/%{commit}/%{name}-%{commit}.tar.gz
# jackson-datatype-hibernate source doesn't include the license file
Source1:       http://www.apache.org/licenses/LICENSE-2.0.txt

BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: fasterxml-oss-parent >= 0:11
BuildRequires: jackson-core >= 0:2.3.0
BuildRequires: jackson-databind >= 0:2.3.0
BuildRequires: jboss-project-dependency-relocations
BuildRequires: javassist

BuildRequires: maven-local
BuildRequires: build-helper-maven-plugin >= 0:1.7
BuildRequires: maven-bundle-plugin >= 0:2.3.7
BuildRequires: maven-compiler-plugin
BuildRequires: maven-deploy-plugin
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-replacer-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-scm-plugin >= 0:1.7
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin

%if 0%{?rhel >= 7}
BuildRequires: xml-resolver
%endif

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Requires: fasterxml-oss-parent >= 0:11
Requires: jackson-core >= 0:2.3.0
Requires: jackson-databind >= 0:2.3.0
Requires: jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils

%description
Parent POM file for add-on module for Jackson JSON processor which handles
Hibernate datatypes.

%package -n %{name}-parent
Summary: Parent POM for %{name}

%description -n %{name}-parent
%{summary}.

# Hibernate 3 sub-package
%if %{with hibernate3}
%package -n %{name_h3}
Summary: Jackson datatype for Hibernate 3
Group: Development/Libraries
BuildRequires: hibernate3
BuildRequires: hibernate3-entitymanager
Requires: hibernate3
Requires: hibernate3-entitymanager
Requires: %{name}-parent = %{epoch}:%{version}-%{release}

%description -n %{name_h3}
Add-on module for Jackson JSON processor which handles Hibernate 3 datatypes;
specifically aspects of lazy-loading.
%endif

# Hibernate 4 sub-package
%package -n %{name_h4}
Summary: Jackson datatype for Hibernate 4
Group: Development/Libraries
%if 0%{?fedora}
BuildRequires: hibernate-core
BuildRequires: hibernate-entitymanager
Requires: hibernate-core
Requires: hibernate-entitymanager
%else
BuildRequires: hibernate4-core
BuildRequires: hibernate4-entitymanager
Requires: hibernate4-core
Requires: hibernate4-entitymanager
%endif
Requires: %{name}-parent = %{epoch}:%{version}-%{release}

%description -n %{name_h4}
Add-on module for Jackson JSON processor which handles Hibernate 4 datatypes;
specifically aspects of lazy-loading.

# Javadoc sub-package
%package -n %{name}-javadoc
Summary: Javadoc for %{name}
Group:   Documentation
BuildRequires: jpackage-utils
Requires: jpackage-utils

%description -n %{name}-javadoc
%{summary}.

%prep
%setup -q -n %{name}-%{commit}

%{__cp} -p %{SOURCE1} .
%{__sed} -i 's/\r//' LICENSE-2.0.txt

%build
%pom_xpath_remove "//pom:dependency[pom:scope='test']"
%pom_xpath_remove "//pom:dependency[pom:scope='test']" hibernate4
%pom_xpath_remove "//pom:dependency[pom:scope='test']" hibernate3

%if %{without hibernate3}
%pom_disable_module hibernate3
%endif

export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://${PWD}/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -B -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Denforcer.skip deploy javadoc:aggregate -Dmaven.test.skip=true

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__mkdir_p} %{buildroot}%{_mavenpomdir}

%{__cp} -p maven2-brew/com/fasterxml/jackson/datatype/%{name}-parent/%{artifact_version}/%{name}-parent-%{artifact_version}.pom %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-parent.pom
for module in 4 %{?_with_hibernate3:3}; do
    artifact="%{name}${module}"
    artifact_version="%{artifact_version}"
    artifact_path="maven2-brew/com/fasterxml/jackson/datatype/${artifact}/${artifact_version}"
    for jar_type in "" "-javadoc" "-sources"; do
        destination="%{buildroot}%{_javadir}/%{name}/${artifact}-${artifact_version}${jar_type}.jar"
        %{__cp} -p ${artifact_path}/${artifact}-${artifact_version}${jar_type}.jar ${destination}
    done
    %{__cp} -p ${artifact_path}/${artifact}-${artifact_version}.pom %{buildroot}%{_mavenpomdir}/JPP.%{name}-${artifact}.pom
done

pushd %{buildroot}%{_javadir}/%{name}
for jar in *-%{artifact_version}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{artifact_version}||g"`; done
popd

#depmaps
%add_maven_depmap JPP.%{name}-%{name}-parent.pom
%add_maven_depmap JPP.%{name}-%{name_h4}.pom %{name}/%{name_h4}.jar -f %{name_h4}
%{?_with_hibernate3:%add_maven_depmap JPP.%{name}-%{name_h3}.pom %{name}/%{name_h3}.jar -f hibernate3}

#javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files -n %{name}-parent
%defattr(0644,root,root,0755)
%doc LICENSE-2.0.txt README.md
%{_mavenpomdir}/JPP.%{name}-%{name}-parent.pom
%{_mavendepmapfragdir}/%{name}

%files -n %{name_h4}
%defattr(0644,root,root,0755)
%doc LICENSE-2.0.txt README.md
%{_javadir}/%{name}/%{name_h4}.jar
%{_javadir}/%{name}/%{name_h4}-%{artifact_version}.jar
%{_javadir}/%{name}/%{name_h4}-javadoc.jar
%{_javadir}/%{name}/%{name_h4}-%{artifact_version}-javadoc.jar
%{_javadir}/%{name}/%{name_h4}-sources.jar
%{_javadir}/%{name}/%{name_h4}-%{artifact_version}-sources.jar
%{_mavenpomdir}/JPP.%{name}-%{name_h4}.pom
%{_mavendepmapfragdir}/%{name}-%{name_h4}

%if %{with hibernate3}
%files -n %{name_h3}
%defattr(0644,root,root,0755)
%doc LICENSE-2.0.txt README.md
%{_javadir}/%{name}/%{name_h3}.jar
%{_javadir}/%{name}/%{name_h3}-%{artifact_version}.jar
%{_javadir}/%{name}/%{name_h3}-javadoc.jar
%{_javadir}/%{name}/%{name_h3}-%{artifact_version}-javadoc.jar
%{_javadir}/%{name}/%{name_h3}-sources.jar
%{_javadir}/%{name}/%{name_h3}-%{artifact_version}-sources.jar
%{_mavenpomdir}/JPP.%{name}-%{name_h3}.pom
%{_mavendepmapfragdir}/%{name}-%{name_h3}
%endif

%files -n %{name}-javadoc
%defattr(0644,root,root,0755)
%doc LICENSE-2.0.txt
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Tue Jul 01 2014 Alex Wood <awood@redhat.com> 0:2.3.0-1
- Initial packaging.
